require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'linux/libc-compat.ph';
require 'linux/types.ph';
unless(defined(&_LINUX_XATTR_H)) {
    eval 'sub _LINUX_XATTR_H () {1;}' unless defined(&_LINUX_XATTR_H);
    if((defined(&__UAPI_DEF_XATTR) ? &__UAPI_DEF_XATTR : undef)) {
	eval 'sub __USE_KERNEL_XATTR_DEFS () {1;}' unless defined(&__USE_KERNEL_XATTR_DEFS);
	eval 'sub XATTR_CREATE () {0x1;}' unless defined(&XATTR_CREATE);
	eval 'sub XATTR_REPLACE () {0x2;}' unless defined(&XATTR_REPLACE);
    }
    eval 'sub XATTR_OS2_PREFIX () {"os2.";}' unless defined(&XATTR_OS2_PREFIX);
    eval 'sub XATTR_OS2_PREFIX_LEN () {($sizeof{ &XATTR_OS2_PREFIX} - 1);}' unless defined(&XATTR_OS2_PREFIX_LEN);
    eval 'sub XATTR_MAC_OSX_PREFIX () {"osx.";}' unless defined(&XATTR_MAC_OSX_PREFIX);
    eval 'sub XATTR_MAC_OSX_PREFIX_LEN () {($sizeof{ &XATTR_MAC_OSX_PREFIX} - 1);}' unless defined(&XATTR_MAC_OSX_PREFIX_LEN);
    eval 'sub XATTR_BTRFS_PREFIX () {"btrfs.";}' unless defined(&XATTR_BTRFS_PREFIX);
    eval 'sub XATTR_BTRFS_PREFIX_LEN () {($sizeof{ &XATTR_BTRFS_PREFIX} - 1);}' unless defined(&XATTR_BTRFS_PREFIX_LEN);
    eval 'sub XATTR_HURD_PREFIX () {"gnu.";}' unless defined(&XATTR_HURD_PREFIX);
    eval 'sub XATTR_HURD_PREFIX_LEN () {($sizeof{ &XATTR_HURD_PREFIX} - 1);}' unless defined(&XATTR_HURD_PREFIX_LEN);
    eval 'sub XATTR_SECURITY_PREFIX () {"security.";}' unless defined(&XATTR_SECURITY_PREFIX);
    eval 'sub XATTR_SECURITY_PREFIX_LEN () {($sizeof{ &XATTR_SECURITY_PREFIX} - 1);}' unless defined(&XATTR_SECURITY_PREFIX_LEN);
    eval 'sub XATTR_SYSTEM_PREFIX () {"system.";}' unless defined(&XATTR_SYSTEM_PREFIX);
    eval 'sub XATTR_SYSTEM_PREFIX_LEN () {($sizeof{ &XATTR_SYSTEM_PREFIX} - 1);}' unless defined(&XATTR_SYSTEM_PREFIX_LEN);
    eval 'sub XATTR_TRUSTED_PREFIX () {"trusted.";}' unless defined(&XATTR_TRUSTED_PREFIX);
    eval 'sub XATTR_TRUSTED_PREFIX_LEN () {($sizeof{ &XATTR_TRUSTED_PREFIX} - 1);}' unless defined(&XATTR_TRUSTED_PREFIX_LEN);
    eval 'sub XATTR_USER_PREFIX () {"user.";}' unless defined(&XATTR_USER_PREFIX);
    eval 'sub XATTR_USER_PREFIX_LEN () {($sizeof{ &XATTR_USER_PREFIX} - 1);}' unless defined(&XATTR_USER_PREFIX_LEN);
    eval 'sub XATTR_EVM_SUFFIX () {"evm";}' unless defined(&XATTR_EVM_SUFFIX);
    eval 'sub XATTR_NAME_EVM () { &XATTR_SECURITY_PREFIX  &XATTR_EVM_SUFFIX;}' unless defined(&XATTR_NAME_EVM);
    eval 'sub XATTR_IMA_SUFFIX () {"ima";}' unless defined(&XATTR_IMA_SUFFIX);
    eval 'sub XATTR_NAME_IMA () { &XATTR_SECURITY_PREFIX  &XATTR_IMA_SUFFIX;}' unless defined(&XATTR_NAME_IMA);
    eval 'sub XATTR_SELINUX_SUFFIX () {"selinux";}' unless defined(&XATTR_SELINUX_SUFFIX);
    eval 'sub XATTR_NAME_SELINUX () { &XATTR_SECURITY_PREFIX  &XATTR_SELINUX_SUFFIX;}' unless defined(&XATTR_NAME_SELINUX);
    eval 'sub XATTR_SMACK_SUFFIX () {"SMACK64";}' unless defined(&XATTR_SMACK_SUFFIX);
    eval 'sub XATTR_SMACK_IPIN () {"SMACK64IPIN";}' unless defined(&XATTR_SMACK_IPIN);
    eval 'sub XATTR_SMACK_IPOUT () {"SMACK64IPOUT";}' unless defined(&XATTR_SMACK_IPOUT);
    eval 'sub XATTR_SMACK_EXEC () {"SMACK64EXEC";}' unless defined(&XATTR_SMACK_EXEC);
    eval 'sub XATTR_SMACK_TRANSMUTE () {"SMACK64TRANSMUTE";}' unless defined(&XATTR_SMACK_TRANSMUTE);
    eval 'sub XATTR_SMACK_MMAP () {"SMACK64MMAP";}' unless defined(&XATTR_SMACK_MMAP);
    eval 'sub XATTR_NAME_SMACK () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_SUFFIX;}' unless defined(&XATTR_NAME_SMACK);
    eval 'sub XATTR_NAME_SMACKIPIN () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_IPIN;}' unless defined(&XATTR_NAME_SMACKIPIN);
    eval 'sub XATTR_NAME_SMACKIPOUT () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_IPOUT;}' unless defined(&XATTR_NAME_SMACKIPOUT);
    eval 'sub XATTR_NAME_SMACKEXEC () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_EXEC;}' unless defined(&XATTR_NAME_SMACKEXEC);
    eval 'sub XATTR_NAME_SMACKTRANSMUTE () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_TRANSMUTE;}' unless defined(&XATTR_NAME_SMACKTRANSMUTE);
    eval 'sub XATTR_NAME_SMACKMMAP () { &XATTR_SECURITY_PREFIX  &XATTR_SMACK_MMAP;}' unless defined(&XATTR_NAME_SMACKMMAP);
    eval 'sub XATTR_APPARMOR_SUFFIX () {"apparmor";}' unless defined(&XATTR_APPARMOR_SUFFIX);
    eval 'sub XATTR_NAME_APPARMOR () { &XATTR_SECURITY_PREFIX  &XATTR_APPARMOR_SUFFIX;}' unless defined(&XATTR_NAME_APPARMOR);
    eval 'sub XATTR_CAPS_SUFFIX () {"capability";}' unless defined(&XATTR_CAPS_SUFFIX);
    eval 'sub XATTR_NAME_CAPS () { &XATTR_SECURITY_PREFIX  &XATTR_CAPS_SUFFIX;}' unless defined(&XATTR_NAME_CAPS);
    eval 'sub XATTR_BPF_LSM_SUFFIX () {"bpf.";}' unless defined(&XATTR_BPF_LSM_SUFFIX);
    eval 'sub XATTR_NAME_BPF_LSM () {( &XATTR_SECURITY_PREFIX  &XATTR_BPF_LSM_SUFFIX);}' unless defined(&XATTR_NAME_BPF_LSM);
    eval 'sub XATTR_NAME_BPF_LSM_LEN () {($sizeof{ &XATTR_NAME_BPF_LSM} - 1);}' unless defined(&XATTR_NAME_BPF_LSM_LEN);
    eval 'sub XATTR_POSIX_ACL_ACCESS () {"posix_acl_access";}' unless defined(&XATTR_POSIX_ACL_ACCESS);
    eval 'sub XATTR_NAME_POSIX_ACL_ACCESS () { &XATTR_SYSTEM_PREFIX  &XATTR_POSIX_ACL_ACCESS;}' unless defined(&XATTR_NAME_POSIX_ACL_ACCESS);
    eval 'sub XATTR_POSIX_ACL_DEFAULT () {"posix_acl_default";}' unless defined(&XATTR_POSIX_ACL_DEFAULT);
    eval 'sub XATTR_NAME_POSIX_ACL_DEFAULT () { &XATTR_SYSTEM_PREFIX  &XATTR_POSIX_ACL_DEFAULT;}' unless defined(&XATTR_NAME_POSIX_ACL_DEFAULT);
}
1;
